Bug 1478994 - Glance fails to start after latest update.
Glance fails to start after latest update.
Status: NEW
Product: Red Hat OpenStack
Classification: Red Hat
Component: python-cryptography (Show other bugs)
10.0 (Newton)
x86_64 Linux
medium Severity high
: ---
: 10.0 (Newton)
Assigned To: RHOS Maint
Shai Revivo
: Triaged, ZStream
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-08-07 12:39 EDT by Siggy Sigwald
Modified: 2017-11-02 13:46 EDT (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Siggy Sigwald 2017-08-07 12:39:30 EDT
Description of problem:
Glance api log shows
2017-08-07 11:26:51.967 4046 CRITICAL glance [-] TypeError: cannot instantiate ctype 'EVP_MD_CTX' of unknown size
2017-08-07 11:26:51.967 4046 ERROR glance Traceback (most recent call last):
2017-08-07 11:26:51.967 4046 ERROR glance   File "/usr/bin/glance-api", line 10, in <module>
2017-08-07 11:26:51.967 4046 ERROR glance     sys.exit(main())
2017-08-07 11:26:51.967 4046 ERROR glance   File "/usr/lib/python2.7/site-packages/glance/cmd/api.py", line 91, in main
2017-08-07 11:26:51.967 4046 ERROR glance     server.start(config.load_paste_app('glance-api'), default_port=9292)
2017-08-07 11:26:51.967 4046 ERROR glance   File "/usr/lib/python2.7/site-packages/glance/common/wsgi.py", line 515, in start
2017-08-07 11:26:51.967 4046 ERROR glance     self.configure()
2017-08-07 11:26:51.967 4046 ERROR glance   File "/usr/lib/python2.7/site-packages/glance/common/wsgi.py", line 589, in configure
2017-08-07 11:26:51.967 4046 ERROR glance     self.configure_socket(old_conf, has_changed)
2017-08-07 11:26:51.967 4046 ERROR glance   File "/usr/lib/python2.7/site-packages/glance/common/wsgi.py", line 740, in configure_socket
2017-08-07 11:26:51.967 4046 ERROR glance     self.sock = ssl_wrap_socket(self._sock)
2017-08-07 11:26:51.967 4046 ERROR glance   File "/usr/lib/python2.7/site-packages/glance/common/wsgi.py", line 354, in ssl_wrap_socket
2017-08-07 11:26:51.967 4046 ERROR glance     utils.validate_key_cert(CONF.key_file, CONF.cert_file)
2017-08-07 11:26:51.967 4046 ERROR glance   File "/usr/lib/python2.7/site-packages/glance/common/utils.py", line 433, in validate_key_cert
2017-08-07 11:26:51.967 4046 ERROR glance     out = crypto.sign(key, data, digest)
2017-08-07 11:26:51.967 4046 ERROR glance   File "/usr/lib/python2.7/site-packages/OpenSSL/crypto.py", line 2403, in sign
2017-08-07 11:26:51.967 4046 ERROR glance     md_ctx = _ffi.new("EVP_MD_CTX*")
2017-08-07 11:26:51.967 4046 ERROR glance TypeError: cannot instantiate ctype 'EVP_MD_CTX' of unknown size
2017-08-07 11:26:51.967 4046 ERROR glance

Version-Release number of selected component (if applicable):
Downgrading python2-cryptography-1.7.2-1.el7.x86_64 to python2-cryptography-1.3.1-3.el7.x86_64 resolves the issue
Comment 2 Cyril Roelandt 2017-08-08 10:10:28 EDT
What is your version of pyopenssl?
Comment 5 Cyril Roelandt 2017-08-09 11:58:11 EDT
@Siggy: this definitely looks like a python2-cryptography issue. Apparently there are two ways to work around it:

- downgrade python2-cryptography (which you did);
- upgrade pyopenssl (and I have no idea why it's not installed on your system, this looks a bit weird).

I think it would make sense to re-target this bug report to python-cryptography. What do you think?

Note You need to log in before you can comment on or make changes to this bug.